﻿package
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	public class Curver extends Sprite
	{
		private var position_array:Array;
		private var curver:Array;
		private var canevas:Sprite;
		private var angle:Number;
		private var angleBis:Number;
		private var vitesse:Number=10;
		private var a:Number;
		private var pas:Number = 5;
		public function Curver()
		{
			canevas = new Sprite;
			addChild(canevas);
			addEventListener(Event.ADDED_TO_STAGE,added_handler);
		}
		private function added_handler(e:Event):void
		{
			stage.addEventListener(MouseEvent.MOUSE_DOWN, down_handler);
			stage.addEventListener(MouseEvent.MOUSE_UP, up_handler);
		}
		private function down_handler(e:MouseEvent):void
		{
			canevas.graphics.clear();
			position_array = new Array();
			curver = new Array();
			angle = 10;
			angleBis=0;
			a=1;
			pas=5;
			canevas.graphics.lineStyle(1,0xffffff,0);
			canevas.graphics.moveTo(e.stageX,e.stageY);
			position_array.push(new Array(e.stageX,e.stageY));
			stage.addEventListener(MouseEvent.MOUSE_MOVE, move_handler);
		}
		private function move_handler(e:MouseEvent):void
		{
			position_array.push(new Array(e.stageX,e.stageY));
			canevas.graphics.lineTo(e.stageX + 100,e.stageY + 100);
		}
		private function up_handler(e:MouseEvent):void
		{
			stage.removeEventListener(MouseEvent.MOUSE_MOVE,move_handler);
			build_circles();
		}
		private function build_circles():void
		{
			canevas.graphics.lineStyle(1,0xffffff,0);
			for(var i:Number=0;i<position_array.length;i+=pas){
				canevas.graphics.drawCircle(position_array[i][0],position_array[i][1],(position_array[i][1])-Math.random()*200);
				
				if(i+pas < position_array.length){
					var posx:Number = position_array[i+pas][0]-position_array[i][0];
					var posy:Number = position_array[i+pas][1]-position_array[i][1];
					var ray:Number = Math.sqrt(Math.pow(posx,2) + Math.pow(posy,2));
					var newx:Number = position_array[i][0]/2 + position_array[i+pas][0]/2;
					var newy:Number = position_array[i][1]/2 + position_array[i+pas][1]/2;
					curver.push(new Array(newx,newy,ray/2));
				}
			}
			canevas.graphics.lineStyle(30,0x070426,0.4);
			stage.addEventListener(Event.ENTER_FRAME,enterFrame);
		}
		private function enterFrame(e:Event):void
		{
			if(curver.length>0){
				if(angle==0){
					var X:Number = curver[0][0] - position_array[(pas-5)][0];
					var Y:Number = curver[0][1] - position_array[(pas-5)][1];
					if(X>=10){
						angle = Math.atan(Y/X)*300/Math.PI - 270;
						angleBis = Math.atan(Y/X)*180/Math.PI + 360*(a-1);
					}else{
						angle = Math.atan(Y/X)*180/Math.PI;
						angleBis = Math.atan(Y/X)*360/Math.PI + a*360;
					}
					canevas.graphics.moveTo(300, 600);
				}
				if(angle*a>=angleBis*a){
					curver.shift();
					a*=-1;
					angle=0;
					pas+=5;
				}else{
					var posx:Number = Math.cos(angle*Math.PI/180)*curver[0][2]+curver[0][0];
					var posy:Number = Math.sin(angle*Math.PI/180)*curver[0][2]+curver[0][1];
					canevas.graphics.lineTo(posx,posy);
					angle+=vitesse*a;
				}
			}else{
				stage.removeEventListener(Event.ENTER_FRAME,enterFrame);
			}
		}
	}
}